Unit asp1e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure asp1e(var A :Array of Extended; var B :Array of Extended;
                var X :Array of Extended; var T :Array of Extended;
                var S :Array of Integer; N :Integer; M :Integer;
                P :Integer);

implementation

procedure asp1e(var A :Array of Extended; var B :Array of Extended;
                var X :Array of Extended; var T :Array of Extended;
                var S :Array of Integer; N :Integer; M :Integer;
                P :Integer);
var
I,J,K,L :Integer;
E,F,R,D,H :Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26;
begin
if ( P = 1 ) 
 then goto _1;
goto _18;
_1:
for K:=1 to N do
 begin
  if ( K <> M ) 
   then goto _2;
  T[K-1] := A[(K-1)+(K-1)*N];
  A[(K-1)+(K-1)*N] := 0.e0;
  S[K-1] := K;
  goto _18;
_2:
  L := K;
  E := 0.e0;
  for I:=K to N do
   begin
    F := 0.e0;
    for J:=K to M do
     begin
      R := Abs(A[(I-1)+(J-1)*N]);
      if ( F < R ) 
       then F := R;
_3:
     end;
    H := 1.e0/F;
    D := 0.e0;
    for J:=K to M do
     begin
      R := A[(I-1)+(J-1)*N]*H;
_4:
      D := D+R*R;
     end;
    F := Sqrt(D)*F;
    if ( E >= F ) 
     then goto _5;
    E := F;
    L := I;
_5:
   end;
  if ( L = K ) 
   then goto _7;
  for J:=1 to M do
   begin
    R := A[(L-1)+(J-1)*N];
    A[(L-1)+(J-1)*N] := A[(K-1)+(J-1)*N];
    A[(K-1)+(J-1)*N] := R;
_6:
   end;
_7:
  S[K-1] := L;
  F := 1.e0/E;
  for J:=K to M do
   begin
_8:
    T[J-1] := A[(K-1)+(J-1)*N]*F;
   end;
  if ( T[K-1] <> 0.e0 ) 
   then goto _9;
  T[K-1] := 1.e0;
  D := -E;
  goto _11;
_9:
  D := Sign(1.e0,T[K-1]);
  R := 1.e0+Abs(T[K-1]);
  T[K-1] := D*R;
  R := 1.e0/Sqrt(R);
  for J:=K to M do
   begin
_10:
    T[J-1] := T[J-1]*R;
   end;
  D := -E*D;
_11:
  for J:=K to M do
   begin
_12:
    A[(K-1)+(J-1)*N] := T[J-1];
   end;
  if ( K = N ) 
   then goto _16;
  L := K+1;
  for I:=L to N do
   begin
    E := 0.e0;
    for J:=K to M do
     begin
_13:
      E := E+A[(I-1)+(J-1)*N]*T[J-1];
     end;
    for J:=K to M do
     begin
_14:
      A[(I-1)+(J-1)*N] := A[(I-1)+(J-1)*N]-E*T[J-1];
     end;
_15:
   end;
_16:
  T[K-1] := D;
_17:
 end;
_18:
for I:=1 to N do
 begin
  K := S[I-1];
  R := B[I-1];
  B[I-1] := B[K-1];
  B[K-1] := R;
_19:
 end;
X[0] := B[0]/T[0];
if ( N = 1 ) 
 then goto _22;
for I:=2 to N do
 begin
  L := I-1;
  R := 0.e0;
  for J:=1 to L do
   begin
_20:
    R := R+A[(I-1)+(J-1)*N]*X[J-1];
   end;
  X[I-1] := (B[I-1]-R)/T[I-1];
_21:
 end;
_22:
for I:=N to M do
 begin
  if ( I = N ) 
   then goto _23;
  X[I-1] := 0.e0;
_23:
 end;
I := N;
_24:
R := 0.e0;
for J:=I to M do
 begin
_25:
  R := R+A[(I-1)+(J-1)*N]*X[J-1];
 end;
for J:=I to M do
 begin
_26:
  X[J-1] := X[J-1]-R*A[(I-1)+(J-1)*N];
 end;
I := I-1;
if ( I >= 1 ) 
 then goto _24;
end;

end.
